﻿Imports System.Data.OleDb

Public Class winMember
    Dim IsSelectedMember As Integer = -1

    Private Sub Updatedgv()
        Dim data As OleDbDataReader = GetMembers()
        Dim i As Integer = 1
        Dim numberOfData As Integer = SQLScalarQuery("SELECT COUNT(numAdh) FROM Adherent")
        dgvMembers.ColumnCount = 1
        dgvMembers.RowCount = 1
        dgvMembers(0, 0).Value = Nothing
        data.Read()
        Do While i <= numberOfData
            dgvMembers.RowCount = i
            dgvMembers(0, i - 1).Value = data.Item(0).ToString & " " & data.Item(1).ToString
            i = i + 1
            data.Read()
        Loop
        Enabletbx(False)
        IsSelectedMember = -1
        data.Close()
    End Sub

    Private Sub LoadMember(ByVal ident As Integer)
        MsgBox("SELECT nomAdh, prenomAdh, telAdh, mailAdh, dateNaissAdh, codeVille FROM Adherent WHERE numAdh=" & ident)
        Dim data As OleDbDataReader = SQLQuery("SELECT nomAdh, prenomAdh, telAdh, mailAdh, dateNaissAdh, codeVille FROM Adherent WHERE numAdh=" & ident)
        data.Read()
        tbxName.Text = data.Item(0)
        tbxSurname.Text = data.Item(1)
        tbxTelephone.Text = data.Item(2)
        tbxMail.Text = data.Item(3)
        tbxDateOfBirth.Text = data.Item(4)
        tbxCity.Text = data.Item(5)
        data.Close()
        IsSelectedMember = ident
        Enabletbx(False)
    End Sub

    Private Sub Enabletbx(ByVal position As Boolean)
        tbxName.Enabled = position
        tbxSurname.Enabled = position
        tbxTelephone.Enabled = position
        tbxMail.Enabled = position
        tbxDateOfBirth.Enabled = position
        tbxCity.Enabled = position
    End Sub

    Private Sub ClearAlltbx()
        tbxName.Text = Nothing
        tbxSurname.Text = Nothing
        tbxTelephone.Text = Nothing
        tbxMail.Text = Nothing
        tbxDateOfBirth.Text = Nothing
        tbxCity.Text = Nothing
    End Sub

    Private Function Checktbx() As Boolean
        If tbxName.Text = Nothing Or Len(tbxName.Text) > 20 Then
            MsgBox("Nom incorrect")
            Return False
        ElseIf tbxSurname.Text = Nothing Or Len(tbxSurname.Text) > 20 Then
            MsgBox("Prénom incorrect")
            Return False
        ElseIf tbxDateOfBirth.Text = Nothing Or Len(tbxDateOfBirth.Text) < 6 Then
            MsgBox("Date de naissance incorrecte")
            Return False
        ElseIf tbxTelephone.Text = Nothing Or Len(tbxTelephone.Text) < 10 Then
            MsgBox("Numéro de téléphone incorrect")
            Return False
        ElseIf tbxMail.Text = Nothing Or Len(tbxMail.Text) < 8 Then
            MsgBox("Adresse de courrier électronique incorrecte")
            Return False
        Else
            Return True
        End If
    End Function

    Private Sub btnCancel_Click(sender As Object, e As EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub

    Private Sub winMember_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Enabletbx(False)
        btnOK.Hide()
        btnSave.Hide()
        Updatedgv()
    End Sub

    Private Sub dgvMembers_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvMembers.CellClick
        If dgvMembers.CurrentCell.Value <> Nothing Then
            LoadMember(dgvMembers.CurrentCell.RowIndex)
            Enabletbx(False)
        End If
    End Sub

    Private Sub btnModify_Click(sender As Object, e As EventArgs) Handles btnModify.Click
        If IsSelectedMember <> -1 Then
            Enabletbx(True)
            btnModify.Hide()
            btnOK.Show()
            btnNewMember.Enabled = False
            btnDeleteMember.Enabled = False
            btnCancel.Enabled = False
            dgvMembers.Enabled = False
        Else
            MsgBox("Modification impossible: aucun adhérent sélectionné")
        End If
    End Sub

    Private Sub btnOK_Click(sender As Object, e As EventArgs) Handles btnOK.Click
        If Checktbx() Then
            UpdateMember(IsSelectedMember, tbxName.Text, tbxSurname.Text, tbxDateOfBirth.Text, tbxTelephone.Text, tbxMail.Text, tbxCity.Text)
            Updatedgv()
        End If
    End Sub

    Private Sub btnDeleteMember_Click(sender As Object, e As EventArgs) Handles btnDeleteMember.Click
        If IsSelectedMember <> -1 Then
            DeleteMember(IsSelectedMember)
            Updatedgv()
        Else
            MsgBox("Suppression impossible: aucun adhérent sélectionné")
        End If
    End Sub

    Private Sub btnNewMember_Click(sender As Object, e As EventArgs) Handles btnNewMember.Click
        ClearAlltbx()
        Enabletbx(True)
        btnModify.Hide()
        btnNewMember.Hide()
        btnSave.Show()
        btnDeleteMember.Enabled = False
        btnCancel.Enabled = False
        dgvMembers.Enabled = False
    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        If Checktbx() Then
            Dim ident As Integer = 0
            If dgvMembers(0, 0).Value = Nothing Then
                ident = 0
            Else
                ident = dgvMembers.RowCount
            End If
            AddMember(ident, tbxName.Text, tbxSurname.Text, tbxDateOfBirth.Text, tbxTelephone.Text, tbxMail.Text, tbxCity.Text)
            btnModify.Show()
            btnNewMember.Show()
            btnSave.Hide()
            btnDeleteMember.Enabled = True
            btnCancel.Enabled = True
            dgvMembers.Enabled = True
            ClearAlltbx()
            Updatedgv()
        End If
    End Sub
End Class